
#define SIP_CT_MAX_HDRS       20
typedef struct
{
        int      hdrtype;
        int      hdrlen;
        char    *hdrptr;
} sip_hdr_list_t;


typedef struct 
{
    int8_t    msgtype;        //Request or Status?
    int8_t    method;         //Register or Invite or etc?
    int8_t    hdrcount;       //Number of headers in our hdrlist
    int8_t    conttype;       //SDP or etc?
    int8_t    revent;         //Notify special event to fsm
    int8_t    rrflag;         //Message with record-route? 
    int8_t    msgdir;         //Outbound or Inbound?
    int8_t    callid;         //Callid within alginfo
    int8_t    proto;          //Message transport proto
    int8_t    sdplendiff;     //SDP len diff after mangle
    int8_t    msglendiff;     //Message len diff after mangle

    enum ip_conntrack_info ctinfo;    //Message dir w.r.t to Netfilter
    struct ip_conntrack    *ct;       //Conntrack of this message 
    struct ip_conntrack    *master;   //Master conntrack for this message
    struct sk_buff         **pskb;    //Packet skbuffer
    struct iphdr           *iph;      //IP header pointer
    struct udphdr          *udph;     //UDP header pointer
    struct tcphdr          *tcph;     //TCP header pointer
    char                   *msgptr;   //Pointer to the sip message
    char                   *sdpptr;   //Pointer to the sdp content

    int16_t    msglen;
    int16_t    used;      //new or used
    int16_t    sdplen;
    int16_t    expires;
    int16_t    status;         //Status code
    u_int16_t  rtcpnatport;

    sip_hdr_list_t hdrlist[SIP_CT_MAX_HDRS];
} sip_msg_info_t;


